import { NextConfig } from 'next';

interface HighlightConfigOptions {
    uploadSourceMaps?: boolean;
    configureHighlightProxy?: boolean;
    apiKey?: string;
    appVersion?: string;
    serviceName?: string;
    sourceMapsPath?: string;
    sourceMapsBasePath?: string;
}
type NextConfigObject = NextConfig;
type NextConfigFunction = (phase: string, { defaultConfig }: {
    defaultConfig: any;
}) => NextConfig;
type NextConfigAsyncFunction = (phase: string, { defaultConfig }: {
    defaultConfig: any;
}) => Promise<NextConfig>;
type NextConfigInput = NextConfigObject | NextConfigFunction | NextConfigAsyncFunction;
declare const withHighlightConfig: (config: NextConfigInput, highlightOpts?: HighlightConfigOptions) => Promise<NextConfig>;

export { withHighlightConfig };
